Summary:	Remote desktop server
Summary(pl.UTF-8):	Serwer remote desktop
Name:		xrdp
Version:	0.9.25.1
Release:	1%{?tld}
License:	Apache v2.0
Group:		X11/Applications/Networking
#Source0Download: https://github.com/neutrinolabs/xrdp/releases
Source0:	https://github.com/neutrinolabs/xrdp/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	f30ad85ce78c8542d4f7b03c28c8815f
Source1:	%{name}.init
Source2:	%{name}.pamd
Source3:	%{name}.README.TLD
Source4:	%{name}.README.TLD.pl
Source5:	startwm.sh
Patch0:		config.patch
Patch1:		quiet.patch
Patch2:		x32.patch
URL:		http://xrdp.org/
BuildRequires:	autoconf >= 2.65
BuildRequires:	automake >= 1:1.7.2
BuildRequires:	fdk-aac-devel >= 0.1.0
BuildRequires:	imlib2-devel >= 1.4.5
BuildRequires:	lame-libs-devel
BuildRequires:	libfuse-devel >= 2.6
BuildRequires:	libjpeg-turbo-devel
BuildRequires:	libtool
BuildRequires:	nasm
BuildRequires:	openssl-devel >= 0.9.8
BuildRequires:	opus-devel
BuildRequires:	pam-devel
BuildRequires:	pixman-devel >= 0.1.0
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXfixes-devel
BuildRequires:	xorg-lib-libXrandr-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	%{name}-libs = %{version}-%{release}
Requires:	/usr/bin/Xvnc
Requires:	fdk-aac >= 0.1.0
Requires:	imlib2 >= 1.4.5
Requires:	libfuse >= 2.6
Requires:	openssl >= 0.9.8
Requires:	pixman >= 0.1.0
Requires:	rc-scripts
Requires:	xinitrc-ng
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
xrdp is an open source Remote Desktop Protocol (rdp) server for
UNIX-like systems. It is capable of accepting connections from
rdesktop and Microsoft's own terminal server / remote desktop clients.

Unlike Windows NT/2000/2003 server, xrdp will not display a Windows
desktop but an X window desktop to the user.

Xrdp uses Xvnc or X11rdp backends to manage the X session.

%description -l pl.UTF-8
xrdp jest serwerem protokołu Remote Desktop (rdp) dla systemów
UNIXowych. Do xrdp można się łączyć zarówno programem rdesktop, jak i
klientami protokołu rdp Microsoftu.

xrdp używa jako backendu Xvnc lub X11rdp.

%package libs
Summary:	xrdp shared libraries
Summary(pl.UTF-8):	Biblioteki współdzielone xrdp
Group:		Libraries

%description libs
xrdp shared libraries.

%description libs -l pl.UTF-8
Biblioteki współdzielone xrdp.

%package devel
Summary:	Header files for xrdp libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek xrdp
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for xrdp libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek xrdp.

%package static
Summary:	Static xrdp libraries
Summary(pl.UTF-8):	Statyczne biblioteki xrdp
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static xrdp libraries.

%description static -l pl.UTF-8
Statyczne biblioteki xrdp.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

install %{SOURCE3} README.TLD
install %{SOURCE4} README.TLD.pl

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd libpainter
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../librfxcodec
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd ..
%configure \
	--enable-fdkaac \
	--enable-fuse \
	--enable-ipv6 \
	--enable-mp3lame \
	--enable-opus \
	--enable-pam-config=redhat \
	--enable-painter \
	--enable-pixman \
	--disable-silent-rules \
	--enable-tjpeg \
	--enable-vsock \
	--with-imlib2

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/%{name},/etc/{pam.d,rc.d/init.d,security}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/xrdp
install %{SOURCE2} $RPM_BUILD_ROOT/etc/pam.d/sesman
%{__rm} $RPM_BUILD_ROOT/etc/pam.d/xrdp-sesman
%{__ln_s} sesman $RPM_BUILD_ROOT/etc/pam.d/xrdp-sesman
:> $RPM_BUILD_ROOT/etc/security/blacklist.sesman

%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/startwm.sh
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/startwm.sh

%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{name}/lib*.{a,la}
# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.la

%pre
%groupadd -g 183 xrdp

%post
/sbin/chkconfig --add xrdp
%service xrdp restart "xrdp server"

%preun
if [ "$1" = "0" ]; then
	%service xrdp stop
	/sbin/chkconfig --del xrdp
fi

%postun
if [ "$1" = "0" ]; then
	%groupremove xrdp
fi

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING NEWS.md README.md README.TLD
%lang(pl) %doc README.TLD.pl
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/sesman
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/security/blacklist.sesman
%attr(640,root,root) /etc/pam.d/xrdp-sesman
%attr(754,root,root) /etc/rc.d/init.d/xrdp
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/pulse
%config(noreplace) %{_sysconfdir}/%{name}/cert.pem
%config(noreplace) %{_sysconfdir}/%{name}/key.pem
%config(noreplace) %{_sysconfdir}/%{name}/rsakeys.ini
%config(noreplace) %{_sysconfdir}/%{name}/sesman.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp_keyboard.ini
%{_sysconfdir}/%{name}/km-*.ini
%config(noreplace) %{_sysconfdir}/%{name}/pulse/default.pa
%attr(755,root,root) %{_sysconfdir}/xrdp/reconnectwm.sh
%attr(755,root,root) %{_sysconfdir}/xrdp/startwm.sh
%attr(755,root,root) %{_bindir}/xrdp-dis
%attr(755,root,root) %{_bindir}/xrdp-genkeymap
%attr(755,root,root) %{_bindir}/xrdp-keygen
%attr(755,root,root) %{_bindir}/xrdp-sesadmin
%attr(755,root,root) %{_bindir}/xrdp-sesrun
%attr(755,root,root) %{_sbindir}/xrdp
%attr(755,root,root) %{_sbindir}/xrdp-chansrv
%attr(755,root,root) %{_sbindir}/xrdp-sesman
%dir %{_libdir}/xrdp
%attr(755,root,root) %{_libdir}/xrdp/libcommon.so*
%attr(755,root,root) %{_libdir}/xrdp/libmc.so*
%attr(755,root,root) %{_libdir}/xrdp/libscp.so*
%attr(755,root,root) %{_libdir}/xrdp/libvnc.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdp.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdpapi.so*
%attr(755,root,root) %{_libdir}/xrdp/libxup.so*
%dir %{_datadir}/xrdp
%{_datadir}/xrdp/ad24b.bmp
%{_datadir}/xrdp/ad256.bmp
%{_datadir}/xrdp/cursor0.cur
%{_datadir}/xrdp/cursor1.cur
%{_datadir}/xrdp/sans-10.fv1
%{_datadir}/xrdp/xrdp24b.bmp
%{_datadir}/xrdp/xrdp256.bmp
%{_datadir}/xrdp/xrdp_logo.bmp
%{_mandir}/man1/xrdp-dis.1*
%{_mandir}/man5/sesman.ini.5*
%{_mandir}/man5/xrdp.ini.5*
%{_mandir}/man8/xrdp-chansrv.8*
%{_mandir}/man8/xrdp-genkeymap.8*
%{_mandir}/man8/xrdp-keygen.8*
%{_mandir}/man8/xrdp-sesadmin.8*
%{_mandir}/man8/xrdp-sesman.8*
%{_mandir}/man8/xrdp-sesrun.8*
%{_mandir}/man8/xrdp.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpainter.so.0
%attr(755,root,root) %{_libdir}/librfxencode.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/librfxencode.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so
%attr(755,root,root) %{_libdir}/librfxencode.so
%{_includedir}/ms-*.h
%{_includedir}/painter.h
%{_includedir}/rfxcodec_common.h
%{_includedir}/rfxcodec_decode.h
%{_includedir}/rfxcodec_encode.h
%{_includedir}/xrdp_client_info.h
%{_includedir}/xrdp_constants.h
%{_includedir}/xrdp_rail.h
%{_includedir}/xrdp_sockets.h
%{_pkgconfigdir}/libpainter.pc
%{_pkgconfigdir}/rfxcodec.pc
%{_pkgconfigdir}/xrdp.pc

%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.a
%attr(755,root,root) %{_libdir}/librfxencode.a
%changelog
* Sat Apr 27 2024 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/xrdp.git;a=log;h=6c4a4bed8900ad0b97915d81afd8d5c9cda7fa74

* Fri Apr 26 2024 Marcin Krol <hawk@tld-linux.org> 6c4a4be
- updated to 0.9.25.1, partial PLD merge

* Thu Mar 31 2022 Marcin Krol <hawk@tld-linux.org> b0d9f24
- updated to 0.9.19, partial PLD merge

* Mon Jan 04 2021 Marcin Krol <hawk@tld-linux.org> b64cfbf
- missing patch

* Mon Jan 04 2021 Marcin Krol <hawk@tld-linux.org> 276e977
- merged PLD changes, updated to 0.9.15

* Sun Aug 16 2020 Marcin Krol <hawk@tld-linux.org> 9f2133f
- updated to 0.9.13.1

* Wed Aug 21 2019 Marcin Krol <hawk@tld-linux.org> febe8bf
- updated to 0.9.11

* Wed May 22 2019 Marcin Krol <hawk@tld-linux.org> ebcd383
- updated to 0.9.10

* Mon Feb 25 2019 Marcin Krol <hawk@tld-linux.org> be08a91
- updated to 0.9.9

* Tue Dec 04 2018 Marcin Krol <hawk@tld-linux.org> 6201d30
- updated to 0.9.8, updated README files

* Thu Sep 06 2018 Marcin Krol <hawk@tld-linux.org> c1ce194
- release 2, disallow root logins and use xrdp group instead of users

* Wed Jul 04 2018 Marcin Krol <hawk@tld-linux.org> bf52492
- updated to 0.9.7

* Tue Jul 03 2018 Marcin Krol <hawk@tld-linux.org> 8c34e42
- release 4

* Thu Jul 23 2015 Marcin Krol <hawk@tld-linux.org> 98c0c55
- release 3

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> 8eb1331
- apply config patch, include startwm.sh script

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> 1d30b4b
- script for starting selected WM

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> 9f57dfd
- updated, can't call scripts outside /etc/xrdp

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> 242b572
- patch original .ini files
- added reuse session patch from ubuntu
- don't delete *.so, we are referencing them from config file
- no need to run ldconfig

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> beb5c30
- missing pam.d symlink + rm sesman.ini before install to be sure
  we get correct version packaged

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> ff65cdb
- patches from debian

* Wed Nov 26 2014 Marcin Krol <hawk@tld-linux.org> 64b912d
- drop kerberos support, we need pam and there is no fallback when
  built with kerberos

